const { generateNanosTransformers } = require("./utils");

const NANOS_TRANSFORMERS = generateNanosTransformers();

const TRANSFORM_RULES = [
  [
    "transform-imports",
    {
      // neetoui
      "@bigbinary/neetoui": {
        transform: "@bigbinary/neetoui/${member}",
        preventFullImport: true,
      },
      neetoui: {
        transform: "neetoui/${member}",
        preventFullImport: true,
      },
      "@bigbinary/neetoui/formik": {
        transform: "@bigbinary/neetoui/formik/${member}",
        preventFullImport: true,
      },
      "neetoui/formik": {
        transform: "neetoui/formik/${member}",
        preventFullImport: true,
      },

      // neeto-thank-you-frontend
      "@bigbinary/neeto-thank-you-frontend": {
        transform: "@bigbinary/neeto-thank-you-frontend/${member}",
        preventFullImport: true,
      },
      neetothankyou: {
        transform: "neetothankyou/${member}",
        preventFullImport: true,
      },

      // neeto-payments-frontend
      "@bigbinary/neeto-payments-frontend": {
        transform: "@bigbinary/neeto-payments-frontend/${member}",
        preventFullImport: true,
      },
      neetopayments: {
        transform: "neetopayments/${member}",
        preventFullImport: true,
      },

      // neeto-icons
      "@bigbinary/neeto-icons": {
        transform: "@bigbinary/neeto-icons/${member}",
        preventFullImport: false,
      },
      neetoicons: {
        transform: "neetoicons/${member}",
        preventFullImport: false,
      },
      "@bigbinary/neeto-icons/typeface-logos": {
        transform: "@bigbinary/neeto-icons/typeface-logos/${member}",
        preventFullImport: false,
      },
      "neetoicons/typeface-logos": {
        transform: "neetoicons/typeface-logos/${member}",
        preventFullImport: false,
      },
      "@bigbinary/neeto-icons/app-icons": {
        transform: "@bigbinary/neeto-icons/app-icons/${member}",
        preventFullImport: false,
      },
      "neetoicons/app-icons": {
        transform: "neetoicons/app-icons/${member}",
        preventFullImport: false,
      },
      "@bigbinary/neeto-icons/logos": {
        transform: "@bigbinary/neeto-icons/logos/${member}",
        preventFullImport: false,
      },
      "neetoicons/logos": {
        transform: "neetoicons/logos/${member}",
        preventFullImport: false,
      },
      "@bigbinary/neeto-icons/misc": {
        transform: "@bigbinary/neeto-icons/misc/${member}",
        preventFullImport: false,
      },
      "neetoicons/misc": {
        transform: "neetoicons/misc/${member}",
        preventFullImport: false,
      },
      ...NANOS_TRANSFORMERS,
    },
  ],
];

module.exports = { TRANSFORM_RULES };
