'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = require('../typeof-D4ZZ_FlZ.js');
var reactUtils_useDisplayErrorPage_useDisplayErrorPage = require('../react-utils/useDisplayErrorPage/useDisplayErrorPage.js');
var initializers_axiosInitializer_index = require('./axiosInitializer/index.js');
var initializers_dayjs = require('./dayjs.js');
var initializers_globalProps = require('./globalProps.js');
var initializers_i18n = require('./i18n.js');
var initializers_logger = require('./logger.js');
var initializers_mixpanel = require('./mixpanel.js');
var initializers_reactDevTools = require('./reactDevTools.js');
require('ramda');
require('zustand');
require('../defineProperty-lChFfVqi.js');
require('axios');
require('i18next');
require('@bigbinary/neeto-cist');
require('@bigbinary/neetoui/Toastr');
require('react-toastify');
require('../utils/axios.js');
require('./constants.js');
require('./axiosInitializer/paramsSerializer.js');
require('qs');
require('dayjs');
require('dayjs/plugin/advancedFormat');
require('dayjs/plugin/customParseFormat');
require('dayjs/plugin/duration');
require('dayjs/plugin/isSameOrAfter');
require('dayjs/plugin/isSameOrBefore');
require('dayjs/plugin/isToday');
require('dayjs/plugin/localeData');
require('dayjs/plugin/localizedFormat');
require('dayjs/plugin/minMax');
require('dayjs/plugin/quarterOfYear');
require('dayjs/plugin/relativeTime');
require('@bigbinary/neeto-commons-frontend/utils/timezonePlugin');
require('dayjs/plugin/updateLocale');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');
require('../utils/localePlugin.js');
require('../index-BskY8dVw.js');
require('react-i18next');
require('./utils/customFormatters.js');
require('dompurify');
require('./utils/customPostProcessors.js');
require('./utils/utils.js');
require('../slicedToArray-BcL7fKuL.js');
require('../unsupportedIterableToArray-BoHMiKNA.js');
require('js-logger');
require('../mixpanel.module-ajRn5e0J.js');

// eslint-disable-next-line import/no-mutable-exports
exports.globalProps = {};
function initializeApplication(_ref) {
  var translationResources = _ref.translationResources,
    skip = _ref.skip;
  if (!(skip !== null && skip !== void 0 && skip.globalProps)) {
    initializers_globalProps();
    // eslint-disable-next-line @bigbinary/neeto/no-globalProps-reassignment
    exports.globalProps = window.globalProps;
  }
  if (_typeof._typeof(skip === null || skip === void 0 ? void 0 : skip.axios) === "object" || !(skip !== null && skip !== void 0 && skip.axios)) {
    initializers_axiosInitializer_index(skip === null || skip === void 0 ? void 0 : skip.axios);
  }
  if (!(skip !== null && skip !== void 0 && skip.i18n)) initializers_i18n.default(translationResources);
  if (!(skip !== null && skip !== void 0 && skip.logger)) initializers_logger();
  if (!(skip !== null && skip !== void 0 && skip.dayjs)) initializers_dayjs(skip === null || skip === void 0 ? void 0 : skip.timezone);
  if (process.env.NODE_ENV === "production") initializers_reactDevTools();
  var pageLoader = document.getElementById("neeto-page-loader");
  if (pageLoader) pageLoader.remove();
  initializers_mixpanel(skip);
}

exports.useDisplayErrorPage = reactUtils_useDisplayErrorPage_useDisplayErrorPage.default;
Object.defineProperty(exports, "taxonomies", {
  enumerable: true,
  get: function () { return initializers_i18n.taxonomies; }
});
exports.default = initializeApplication;
//# sourceMappingURL=index.js.map
