'use strict';

var initializers_constants = require('../constants.js');

var sentenceCase = function sentenceCase(value) {
  return value.charAt(0).toLocaleUpperCase() + value.slice(1);
};
var sentenceCaseProcessor = {
  type: "postProcessor",
  name: "sentenceCaseProcessor",
  process: function process(value) {
    var shouldSentenceCase = value.startsWith(initializers_constants.LOWERCASED);
    value = value.replace(initializers_constants.LOWERCASED_GLOBAL_REGEX, "");
    return shouldSentenceCase ? sentenceCase(value) : value;
  }
};

exports.sentenceCaseProcessor = sentenceCaseProcessor;
//# sourceMappingURL=customPostProcessors.js.map
