'use strict';

var zustand = require('zustand');
var shallow = require('zustand/shallow');

var useKeyboardShortcutsStore = zustand.create(function (set) {
  return {
    isOpen: false,
    setIsOpen: function setIsOpen(arg) {
      if (typeof arg === "function") {
        set(function (state) {
          return {
            isOpen: arg(state.isOpen)
          };
        });
      } else {
        set({
          isOpen: arg
        });
      }
    }
  };
});
var useKeyboardShortcutsPaneState = function useKeyboardShortcutsPaneState() {
  return useKeyboardShortcutsStore(function (_ref) {
    var isOpen = _ref.isOpen,
      setIsOpen = _ref.setIsOpen;
    return [isOpen, setIsOpen];
  }, shallow.shallow);
};

module.exports = useKeyboardShortcutsPaneState;
//# sourceMappingURL=useKeyboardShortcutsPaneState.js.map
