'use strict';

var defineProperty = require('../../defineProperty-lChFfVqi.js');
var react = require('react');
var reactQuery = require('@tanstack/react-query');
var ramda = require('ramda');
var reactUtils_constants_constants = require('../constants/constants.js');
var utils_general = require('../../utils/general.js');
require('../../typeof-D4ZZ_FlZ.js');
require('../../objectWithoutProperties-wSsbHFcG.js');
require('../../slicedToArray-BcL7fKuL.js');
require('../../unsupportedIterableToArray-BoHMiKNA.js');
require('../../index-BskY8dVw.js');
require('i18next');
require('@bigbinary/neeto-cist');
require('@bigbinary/neetoui/Toastr');
require('qs');

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), true).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var localStorageQueryCache = {
  set: function set(key, data) {
    var cache = localStorageQueryCache.getAll();
    var newCache = _objectSpread(_objectSpread({}, cache), {}, defineProperty._defineProperty({}, key, {
      data: data,
      modifiedAt: Date.now()
    }));
    utils_general.setToLocalStorage(reactUtils_constants_constants.QUERY_CACHE_NAME_SPACE, newCache);
  },
  getAll: function getAll() {
    var cache = utils_general.getFromLocalStorage(reactUtils_constants_constants.QUERY_CACHE_NAME_SPACE);
    if (!cache) return {};
    return cache;
  },
  get: function get(key) {
    return localStorageQueryCache.getAll()[key];
  }
};
var isOutdated = function isOutdated(localCache, staleTime) {
  if (ramda.isNil(localCache)) return true;
  if (ramda.isNil(staleTime)) return false;
  return localCache.modifiedAt <= Date.now() - staleTime;
};
var usePersistedQuery = function usePersistedQuery(queryKey, fetch, options) {
  var queryResult = reactQuery.useQuery(_objectSpread({
    queryKey: queryKey,
    queryFn: fetch
  }, options));
  var localCache = localStorageQueryCache.get(queryKey);
  react.useEffect(function () {
    if (!queryResult.isSuccess) return;
    localStorageQueryCache.set(queryKey, queryResult.data);
  }, [queryKey, queryResult.data, queryResult.isSuccess]);
  if (isOutdated(localCache, options === null || options === void 0 ? void 0 : options.staleTime)) {
    return _objectSpread(_objectSpread({}, queryResult), {}, {
      isFreshLoading: queryResult.isLoading
    });
  }
  return _objectSpread(_objectSpread({}, queryResult), {}, {
    data: queryResult.data || localCache.data,
    isFreshLoading: false
  });
};
usePersistedQuery.getCache = localStorageQueryCache.get;

module.exports = usePersistedQuery;
//# sourceMappingURL=usePersistedQuery.js.map
