'use strict';

var defineProperty = require('../defineProperty-lChFfVqi.js');
var toConsumableArray = require('../toConsumableArray-tBKHqzE3.js');
var pureDayjs = require('dayjs');
require('../typeof-D4ZZ_FlZ.js');
require('../unsupportedIterableToArray-BoHMiKNA.js');

function _classCallCheck(a, n) {
  if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties(e, r) {
  for (var t = 0; t < r.length; t++) {
    var o = r[t];
    o.enumerable = o.enumerable || false, o.configurable = true, "value" in o && (o.writable = true), Object.defineProperty(e, defineProperty.toPropertyKey(o.key), o);
  }
}
function _createClass(e, r, t) {
  return r && _defineProperties(e.prototype, r), Object.defineProperty(e, "prototype", {
    writable: false
  }), e;
}

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), true).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var LRUCache = /*#__PURE__*/function () {
  function LRUCache(limit) {
    _classCallCheck(this, LRUCache);
    this.limit = limit;
    this.cache = new Map();
  }
  return _createClass(LRUCache, [{
    key: "get",
    value: function get(key) {
      var value = this.cache.get(key);
      this.cache["delete"](key);
      this.cache.set(key, value);
      return value;
    }
  }, {
    key: "set",
    value: function set(key, value) {
      if (this.cache.size >= this.limit) {
        var oldestKey = this.cache.keys().next().value;
        this.cache["delete"](oldestKey);
      }
      this.cache.set(key, value);
    }
  }, {
    key: "has",
    value: function has(key) {
      return this.cache.has(key);
    }
  }]);
}();
var hasTimezone = function hasTimezone(dateString) {
  var timezoneRegex = /Z|[+-]\d{2}:\d{2}$|[+-]\d{4}$|GMT([+-]\d{4})?$/;
  return timezoneRegex.test(dateString);
};
var cache = new LRUCache(1000);
var dayjs = function dayjs() {
  var _args$;
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  var cacheKey = JSON.stringify(args);
  if (cache.has(cacheKey) && args[0] !== undefined) return cache.get(cacheKey);
  var userTimezone = pureDayjs.tz().$x.$timezone;
  var browserTimezone = pureDayjs.tz.guess();
  var timezone = userTimezone || browserTimezone;
  if (userTimezone === browserTimezone || userTimezone === undefined) {
    var _result = pureDayjs.apply(void 0, args);
    if (args[0] !== undefined) cache.set(cacheKey, _result);
    return _result;
  }
  if (args.length > 0 && (typeof args[0] === "string" || args[0] === null) || args.length > 2) {
    if (hasTimezone(args[0])) {
      args[0] = pureDayjs.apply(void 0, args);
    } else {
      args[0] = pureDayjs.apply(void 0, args).format("YYYY-MM-DD HH:mm:ss");
      args[1] = "YYYY-MM-DD HH:mm:ss";
    }
  }
  if (((_args$ = args[0]) === null || _args$ === void 0 ? void 0 : _args$.toString()) === "Invalid Date") {
    var _result2 = pureDayjs.apply(void 0, args);
    if (args[0] !== undefined) cache.set(cacheKey, _result2);
    return _result2;
  }
  var result = args.length < 2 ? pureDayjs.tz.apply(pureDayjs, args) : pureDayjs.tz.apply(pureDayjs, toConsumableArray._toConsumableArray(args.slice(0, 2)).concat([timezone]));
  if (args[0] !== undefined) cache.set(cacheKey, result);
  return result;
};
Object.assign(dayjs, _objectSpread({}, pureDayjs));

module.exports = dayjs;
//# sourceMappingURL=dayjs.js.map
