import { _ as _typeof } from '../typeof-D-UKOauR.js';
export { default as useDisplayErrorPage } from '../react-utils/useDisplayErrorPage/useDisplayErrorPage.js';
import initializeAxios from './axiosInitializer/index.js';
import initializeDayjs from './dayjs.js';
import initializeGlobalProps from './globalProps.js';
import initializeI18n from './i18n.js';
export { taxonomies } from './i18n.js';
import initializeLogger from './logger.js';
import initializeMixpanel from './mixpanel.js';
import disableReactDevTools from './reactDevTools.js';
import 'ramda';
import 'zustand';
import '../defineProperty-CrCYjjU3.js';
import 'axios';
import 'i18next';
import '@bigbinary/neeto-cist';
import '@bigbinary/neetoui/Toastr';
import 'react-toastify';
import '../utils/axios.js';
import './constants.js';
import './axiosInitializer/paramsSerializer.js';
import 'qs';
import 'dayjs';
import 'dayjs/plugin/advancedFormat';
import 'dayjs/plugin/customParseFormat';
import 'dayjs/plugin/duration';
import 'dayjs/plugin/isSameOrAfter';
import 'dayjs/plugin/isSameOrBefore';
import 'dayjs/plugin/isToday';
import 'dayjs/plugin/localeData';
import 'dayjs/plugin/localizedFormat';
import 'dayjs/plugin/minMax';
import 'dayjs/plugin/quarterOfYear';
import 'dayjs/plugin/relativeTime';
import '@bigbinary/neeto-commons-frontend/utils/timezonePlugin';
import 'dayjs/plugin/updateLocale';
import 'dayjs/plugin/utc';
import 'dayjs/plugin/weekday';
import 'dayjs/plugin/weekOfYear';
import '../utils/localePlugin.js';
import '../index-CoBEoJgD.js';
import 'react-i18next';
import './utils/customFormatters.js';
import 'dompurify';
import './utils/customPostProcessors.js';
import './utils/utils.js';
import '../slicedToArray-DmsZvA_9.js';
import '../unsupportedIterableToArray-Dqz8Y8_I.js';
import 'js-logger';
import '../mixpanel.module-Bu2zrBMQ.js';

// eslint-disable-next-line import/no-mutable-exports
var globalProps = {};
function initializeApplication(_ref) {
  var translationResources = _ref.translationResources,
    skip = _ref.skip;
  if (!(skip !== null && skip !== void 0 && skip.globalProps)) {
    initializeGlobalProps();
    // eslint-disable-next-line @bigbinary/neeto/no-globalProps-reassignment
    globalProps = window.globalProps;
  }
  if (_typeof(skip === null || skip === void 0 ? void 0 : skip.axios) === "object" || !(skip !== null && skip !== void 0 && skip.axios)) {
    initializeAxios(skip === null || skip === void 0 ? void 0 : skip.axios);
  }
  if (!(skip !== null && skip !== void 0 && skip.i18n)) initializeI18n(translationResources);
  if (!(skip !== null && skip !== void 0 && skip.logger)) initializeLogger();
  if (!(skip !== null && skip !== void 0 && skip.dayjs)) initializeDayjs(skip === null || skip === void 0 ? void 0 : skip.timezone);
  if (process.env.NODE_ENV === "production") disableReactDevTools();
  var pageLoader = document.getElementById("neeto-page-loader");
  if (pageLoader) pageLoader.remove();
  initializeMixpanel(skip);
}

export { initializeApplication as default, globalProps };
//# sourceMappingURL=index.js.map
