import { LOWERCASED, LOWERCASED_GLOBAL_REGEX } from '../constants.js';

var sentenceCase = function sentenceCase(value) {
  return value.charAt(0).toLocaleUpperCase() + value.slice(1);
};
var sentenceCaseProcessor = {
  type: "postProcessor",
  name: "sentenceCaseProcessor",
  process: function process(value) {
    var shouldSentenceCase = value.startsWith(LOWERCASED);
    value = value.replace(LOWERCASED_GLOBAL_REGEX, "");
    return shouldSentenceCase ? sentenceCase(value) : value;
  }
};

export { sentenceCaseProcessor };
//# sourceMappingURL=customPostProcessors.js.map
