import { useSyncExternalStore } from 'react';
import { equals } from 'ramda';
import { subscribe, getCurrentSize } from './utils.js';
import '../../defineProperty-CrCYjjU3.js';
import '../../typeof-D-UKOauR.js';

var useBreakpoints = function useBreakpoints(breakpointOverrides) {
  var getSnapshot = function getSnapshot() {
    return getCurrentSize(window, breakpointOverrides);
  };
  var currentSize = useSyncExternalStore(subscribe, getSnapshot);
  return {
    currentSize: currentSize,
    isSize: equals(currentSize)
  };
};

export { useBreakpoints as default };
//# sourceMappingURL=index.js.map
