import { create } from 'zustand';
import { shallow } from 'zustand/shallow';

var useKeyboardShortcutsStore = create(function (set) {
  return {
    isOpen: false,
    setIsOpen: function setIsOpen(arg) {
      if (typeof arg === "function") {
        set(function (state) {
          return {
            isOpen: arg(state.isOpen)
          };
        });
      } else {
        set({
          isOpen: arg
        });
      }
    }
  };
});
var useKeyboardShortcutsPaneState = function useKeyboardShortcutsPaneState() {
  return useKeyboardShortcutsStore(function (_ref) {
    var isOpen = _ref.isOpen,
      setIsOpen = _ref.setIsOpen;
    return [isOpen, setIsOpen];
  }, shallow);
};

export { useKeyboardShortcutsPaneState as default };
//# sourceMappingURL=useKeyboardShortcutsPaneState.js.map
